if (typeof nrdp != 'undefined')
{
    console.log('nrdp already defined!');
    return;
}

nrdp = new Object();

nrdp.exit = function()
{
	n_device_api.exit();
};

nrdp.debug = new Object();

nrdp.debug.console = new Object();

nrdp.debug.console.log = function(message)
{
    console.log(message);
};

nrdp.debug.isDebug = function(message)
{
    return ##NRDP_DEBUG##;
};
	

nrdp.debug.console.warn = function(message)
{
    console.log('WARN: ' + message);
};

nrdp.debug.console.error = function(message)
{
    console.log('ERROR: ' + message);
};

nrdp.device = new Object();

nrdp.device.__defineGetter__("language", function() { return '##NRDP_LANGUAGE##' } );
nrdp.device.__defineGetter__("apiUsesHtmlVideoElement", function() { return false; } );


nrdp.device.getModel = function()
{
	return String(n_device_api.getModel());
};

nrdp.device.getSoftwareVersion = function()
{
	return String(n_device_api.getSoftwareVersion());
};

nrdp.device.getCertificationVersion = function()
{
	return String(n_device_api.getCertificationVersion());
};

nrdp.device.getESN = function()
{
	return String(n_device_api.getESN());
};

nrdp.device.getESNPrefix = function()
{
	return String(n_device_api.getESNPrefix());
};

nrdp.device.setUIVersion = function(version)
{
	n_device_api.setUIVersion(version);
};

nrdp.device.isScreensaverOn = function()
{
	return (n_device_api.isScreensaverOn() == 'true');
};

nrdp.device.hasPointer = function()
{
    return (n_device_api.hasPointer() == 'true');
};

nrdp.device.hasKeyboard = function()
{
    return (n_device_api.hasKeyboard() == 'true');
};

nrdp.device.hasOnScreenKeyboard = function()
{
    return (n_device_api.hasOnScreenKeyboard() == 'true');
};

nrdp.device.getLanguage = function()
{
	return String(n_device_api.getLanguage());
};

nrdp.device.launchUrl = function(url)
{
	n_device_api.launchUrl(url);
};

nrdp.device.notifyOnLogin = function()
{
	n_device_api.notifyOnLogin();
};

nrdp.device.notifyOnLogout = function()
{
	n_device_api.notifyOnLogout();
};

nrdp.device.injectKey = function(keyCode)
{
	n_device_api.injectKey(keyCode);
};

nrdp.device.isConnected = function()
{
    return (n_device_api.isConnected() == 'true');
};

nrdp.webapi = new Object();

nrdp.webapi.getConsumerKey = function()
{
	return n_web_api.getConsumerKey();
};

nrdp.webapi.getConsumerSecret = function()
{
	return String(n_web_api.getConsumerSecret());
};

nrdp.webapi.hmacSha1 = function(key, plaintext, handler)
{
        try
        {
            if (typeof(handler) !== 'undefined' && handler !== null)
            {
                var encValue = n_web_api.hmacSha1(key, plaintext);
                handler(encValue);
            }
        }
        catch (e)
        {
            console.log('ERROR: ' + e);
        }
};

nrdp.video = new Object();

nrdp.video.__defineGetter__("MEDIA_ERR_ABORTED", function() { return 'MEDIA_ERR_ABORTED'} );
nrdp.video.__defineGetter__("MEDIA_ERR_NETWORK", function() { return 'MEDIA_ERR_NETWORK'} );
nrdp.video.__defineGetter__("MEDIA_ERR_DECODE", function() { return 'MEDIA_ERR_DECODE'} );
nrdp.video.__defineGetter__("MEDIA_ERR_SRC_NOT_SUPPORTED", function() { return 'MEDIA_ERR_SRC_NOT_SUPPORTED'} );

nrdp.video.__defineGetter__("NETWORK_EMPTY", function() { return 'NETWORK_EMPTY'} );
nrdp.video.__defineGetter__("NETWORK_IDLE", function() { return 'NETWORK_IDLE'} );
nrdp.video.__defineGetter__("NETWORK_LOADING", function() { return 'NETWORK_LOADING'} );
nrdp.video.__defineGetter__("NETWORK_NO_SOURCE", function() { return 'NETWORK_NO_SOURCE'} );

nrdp.video.__defineGetter__("HAVE_NOTHING", function() { return 'HAVE_NOTHING'} );
nrdp.video.__defineGetter__("HAVE_METADATA", function() { return 'HAVE_METADATA'} );
nrdp.video.__defineGetter__("HAVE_CURRENT_DATA", function() { return 'HAVE_CURRENT_DATA'} );
nrdp.video.__defineGetter__("HAVE_FUTURE_DATA", function() { return 'HAVE_FUTURE_DATA'} );
nrdp.video.__defineGetter__("HAVE_ENOUGH_DATA", function() { return 'HAVE_ENOUGH_DATA'} );

nrdp.video.__defineGetter__("instantBitRate", function() { 
    var tmp = (+n_video_api.getInstantBitRate());
    if(tmp < 0) {
        return NaN;
     } else {
        return tmp;
     }    
});

nrdp.video.__defineGetter__("error", function() { 
    var tmp = String(n_video_api.getError());
    if (tmp == '') {
        return null;
    } else {
        return eval('(' + tmp + ')');
    }
});

nrdp.video.__defineGetter__("targetBitRate", function() { 
    var tmp = (+n_video_api.getTargetBitRate());
    if(tmp < 0) {
        return NaN;
     } else {
        return tmp;
     }    
});

nrdp.video.__defineGetter__("isHighDefinition", function() { return Boolean(n_video_api.isHighDefinition()) } );

nrdp.video.__defineGetter__("networkState", function() { return String(n_video_api.getNetworkState()) } );
nrdp.video.__defineGetter__("readyState", function() { return String(n_video_api.getReadyState()) } );

nrdp.video.__defineGetter__("seeking", function() { return Boolean(n_video_api.isSeeking()) } );

nrdp.video.__defineGetter__("currentTime", function() { 
    console.log('currentTime = ' + n_video_api.getCurrentTime());
    var tmp = (+n_video_api.getCurrentTime());
    if(tmp < 0) {
        console.log('currentTime NaN');
        return NaN;
     } else {
        console.log('currentTime value ' + tmp);
        return tmp;
     }
});

nrdp.video.__defineSetter__("currentTime", function(time) { 
    n_video_api.setCurrentTime(time) 
});

nrdp.video.__defineGetter__("duration", function() { 
    var tmp = (+n_video_api.getDuration());
    if(tmp < 0) {
        console.log('duration NaN');
        return NaN;
     } else {
        console.log('duration value ' + tmp);
        return tmp;
     }    
});

nrdp.video.__defineGetter__("paused", function() { return Boolean(n_video_api.isPaused()) } );
nrdp.video.__defineGetter__("ended", function() { return Boolean(n_video_api.isEnded()) } );
nrdp.video.__defineGetter__("autoplay", function() { return Boolean(n_video_api.isAutoplay()) } );
nrdp.video.__defineSetter__("autoplay", function(value) { 
    n_video_api.setAutoplay(value);
});

nrdp.video.play = function()
{
    n_video_api.play();
};

nrdp.video.pause = function()
{
    n_video_api.pause();
};

nrdp.video.stop = function()
{
	n_device_api.setBackResult('player');
};


nrdp.video.getLastPlayedMovieData = function()
{
    return eval('(' + String(n_video_api.getLastPlayedMovieData()) + ')');
};



nrdp.video.setGlobalEventListener = function(listener)
{
    var events = String(n_video_api.getEvents());
    var eventArray = events.split(" ");
    if(typeof(listener) != 'undefined' && listener != null)
    {
        for(i = 0; i < eventArray.length; i++){
            document.addEventListener(eventArray[i], listener, false);
        }
    } else {
        for(i = 0; i < eventArray.length; i++){
            document.removeEventListener(eventArray[i], nrdp.video._globalEventListener, false);
        }    
    }
    nrdp.video._globalEventListener = listener;
};


nrdp.video.addEventListener = function(type, listener, useCapture)
{
    document.addEventListener(type, listener, useCapture);
    n_video_api.registerEvent(type);
};

nrdp.video.removeEventListener = function(type, listener, useCapture)
{
    document.removeEventListener(type, listener, useCapture);
    n_video_api.unregisterEvent(type);
};

nrdp.video.dispatchEvent = function(evt)
{
    document.dispatchEvent(evt);
};

nrdp.video._dispatchEvent = function(evt_type, evt_name)
{
    var evt = document.createEvent(evt_type);
    evt.initEvent(evt_name, true, true);
    nrdp.video.dispatchEvent(evt);
};

nrdp.video._dispatchProgressEvent = function(evt_type, evt_name, loaded, total)
{
    var evt = document.createEvent(evt_type);
    evt.initEvent(evt_name, false, false);
    evt.loaded = loaded;
    evt.total = total;
    evt.lengthComputable = true;
    evt.loadedItems = 0;
    evt.totalItems = 0;
    nrdp.video.dispatchEvent(evt);
};

nrdp.video._dispatchLanguageChangeEvent = function(evt_type, evt_name, old_language, new_language)
{
    nrdp.device.language = new_language;
    var evt = document.createEvent(evt_type);
    evt.initEvent(evt_name, false, false);
    evt.old = old_language;
    nrdp.video.dispatchEvent(evt);
};

nrdp.video.getLastPlayedMovieData = function()
{
    return eval('(' + String(n_video_api.getLastPlayedMovieData()) + ')');
};

